@echo off
if "%1"=="-fix" goto fix
:begin
echo.
echo ... build NASM 0.98.39 w/ Turbo C (8086/DOS) ...
echo.
:setup
if "%CFLAGS%"=="" set CFLAGS=-A -O -mh -f- -w-
echo %%CFLAGS%% = '%CFLAGS%'
echo.
if not exist nasm.c goto end
call %0 -fix
if not exist nasm.c~ goto end
:compile
tcc -c %CFLAGS% -DOF_DOS nasm nasml* fl* insnsa a* la* pa* o* pr* li* e* >NUL
tcc -c %CFLAGS% -DOF_DOS -noutput\ output\outbin output\outobj >NUL
:link
tcc %CFLAGS% -enasm *.obj output\*.obj >NUL
if not exist nasm.exe goto end
:crc
REM ... BEWARE! TC 2.01 is buggy, non-reproducible (except makefile)! ...
echo nasm.exe ...... 3176AED1 (Turbo C++ 1.01)
crc32 nasm.exe
echo.
:pack
if not "%1"=="noupx" upx-nrv -qq --ultra-brute --8086 nasm.exe
goto end
:fix
if exist fixnasm.c goto buildfix
:: *************************************
echo #include "stdio.h">f
echo #include "stdlib.h">>f
echo #include "string.h">>f
echo #define SLASHSTAR while((c=strchr(l,'/')))*c='*'>>f
echo #define CMTLINE fprintf(fo,"/* %%*.*s */\n",n,n,l)>>f
echo int rc=1;int main(int argc,char** argv){>>f
echo if(argc != 1){if(strcmp(argv[1],"-ofdos")==0)rc=fixofdos();>>f
echo else if(strcmp(argv[1],"-date")==0)rc=fixdate(--argc,argv);>>f
echo else if(strcmp(argv[1],"-snprintf")==0)rc=fixsnprf(--argc,argv);>>f
echo }else fputs("OPTIONS:  -ofdos  -date  -snprintf",stderr);>>f
echo return rc;}int fixofdos(void){FILE *fi,*fo; size_t n;>>f
echo char *c,l[100],of[]="outform.h",bak[sizeof(of)+1];strcpy(bak,of);>>f
echo strcat(bak,"~");rename(of,bak);if((fi=fopen(bak,"r"))!= NULL)>>f
echo {fo=fopen(of,"w");while(fgets(l,sizeof(l),fi)){>>f
echo n=strlen(l)-strlen("\n");if(strstr(l,"#define")&&(strstr(l,>>f
echo " OF_WIN32"))){SLASHSTAR; CMTLINE;}else if(strstr(l,>>f
echo "#define")&&(strstr(l," OF_ALL"))){SLASHSTAR; CMTLINE;}>>f
echo else fprintf(fo,"%%s",l);}fclose(fo); fclose(fi); rc=0;}>>f
echo return rc;}int fixdate(int ac,char** av){int i; FILE *fi,*fo;>>f
echo char l[100],bak[80],*d,date[]="__DATE__";size_t n,ds=sizeof(date)-1;>>f
echo if(ac==1)fputs("USAGE:  -date bad.c  (__DATE__ -} \"I_dont_know\")",>>f
echo stderr);else{strcpy(bak,av[2]); strcat(bak,"~"); rename(av[2],bak);>>f
echo if((fi=fopen(bak,"r"))!= NULL){fo=fopen(av[2],"w");while(>>f
echo fgets(l,sizeof(l),fi)){if((d=strstr(l,date))){i=(int)(d-l);>>f
echo n=strlen(l);fprintf(fo,"%%*.*s\"I_dont_know\"",i,i,l);if(n==(i+ds))>>f
echo fputs("",fo);else fprintf(fo,"%%*.*s",n-(i+ds),n-(i+ds),d+ds);}>>f
echo else fprintf(fo,"%%s",l);}fclose(fo); fclose(fi);if(ac==2)>>f
echo remove(bak);rc=0;}}return rc;}int fixsnprf(int ac,char** av)>>f
echo {int num=0;FILE *fi,*fo;char l[100],bak[80],*c;if(ac==1)>>f
echo fputs("USAGE:  -snprintf badfile.c  (snprintf -} sprintf)",stderr);>>f
echo else{strcpy(bak,av[2]); strcat(bak,"~"); rename(av[2],bak);>>f
echo if((fi=fopen(bak,"r"))!= NULL){fo=fopen(av[2],"w");while(>>f
echo fgets(l,sizeof(l),fi)){if(++num==1)fprintf(fo,>>f
echo "#define snprintf sprintf\n#define vsnprintf vsprintf\n");>>f
echo if(strstr(l,"snprintf")&&((c=strchr(l,','))))fprintf(fo,"%%*.*s">>f
echo "%%s",(int)(c-l),(int)(c-l),l,strchr(c+1,','));else fprintf(>>f
echo fo,"%%s",l);}fclose(fo);fclose(fi);rc=0;}}return rc;}>>f
:: *************************************
if not exist f goto end
ren f fixnasm.c
:buildfix
tcc %CFLAGS% fixnasm >NUL
del fixnasm.obj >NUL
fixnasm.exe -ofdos
fixnasm.exe -date nasm.c
for %%a in (nasm listing labels preproc) do fixnasm.exe -snprintf %%a.c
goto bye
:end
if "%CFLAGS%"=="-A -O -mh -f- -w-" set CFLAGS=
:bye
